import os
import sys

from ddk_converter import binary_to_ddk, table_to_text

print(os.environ, file = sys.stderr)

raw_params = list(map(lambda x: x.split("="), os.environ['QUERY_STRING'].split("&")))
baked_params = {k:v for (k, v) in raw_params}
bp = baked_params

if all([i in bp for i in ('x', 'k', 'op')]):
    x = bp['x']
    k = int(bp['k'])

    if bp['op'] == "binary-ddk":
        dt, result, formatted_result = binary_to_ddk(k, x)

        print(f"Content-Type: text/plain; charset=UTF-8\n"
              f"\n"
              f"{table_to_text(dt)}\n"
              f"Result: {result}\n"
              f"Formatted result: {formatted_result}")
    else:
        print("Content-Type: text/plain; charset=UTF-8\r\n\r\nThis operation is not supported yet")
else:
    print("Content-Type: text/plain; charset=UTF-8\r\n\r\nCheck your input!")
